if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::Hooks::ServerControl)
		exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
	RTB_registerPref("Allow Cloaking", "Minecraft Creeper", "Pref::Server::MC_Creeper::AllowCloaking", "bool", "Player_Creeper", 1, 0, 0);
}
else if($Pref::Server::MC_Creeper::AllowCloaking $= "")
	$Pref::Server::MC_Creeper::AllowCloaking = 1;

datablock TSShapeConstructor(CreeperDts)
{
	baseShape  = "./Creeper.dts";
	sequence0  = "./mc_root.dsq root";

	sequence1  = "./mc_walk.dsq run";
	sequence2  = "./mc_walk.dsq walk";
	sequence3  = "./mc_walk.dsq back";
	sequence4  = "./mc_walk.dsq side";

	sequence5  = "./mc_crouch.dsq crouch";
	sequence6  = "./mc_walk.dsq crouchrun";
	sequence7  = "./mc_walk.dsq crouchback";
	sequence8  = "./mc_walk.dsq crouchside";

	sequence9  = "./mc_look.dsq look";
	sequence10 = "./mc_headside.dsq headside";
	sequence11 = "./mc_root.dsq headup";

	sequence23 = "./mc_death1.dsq death1";
};

datablock DebrisData( CreeperDebris )
{
	explodeOnMaxBounce = false;
	elasticity = 0.15;
	friction = 0.5;
	lifetime = 4.0;
	lifetimeVariance = 0.0;
	minSpinSpeed = 40;
	maxSpinSpeed = 600;
	numBounces = 5;
	bounceVariance = 0;
	staticOnMaxBounce = true;
	gravModifier = 1.0;
	useRadiusMass = true;
	baseRadius = 1;
	velocity = 20.0;
	velocityVariance = 12.0;
};

datablock PlayerData(PlayerMCCreeper : PlayerStandardArmor)
{
	shapeFile = "./Creeper.dts";
	boundingBox = "5 5 10.5";
	crouchboundingBox = "5 5 10.5";
	canJet = 0;
	uiName = "MC Creeper";
	maxDamage = 100;
	
	maxTools = 0;   //The creeper can carry no weapons. It is its weapon.
	maxWeapons = 0;
};

//AddDamageType("Creeper", '%1 was blown up by a creeper!', '%1 was blown up by Creeper %2!', 1, 1);   //Unused as of yet.

package CreeperGoesBoom
{
	function Armor::onTrigger(%data, %this, %trig, %tog)
	{
		if(%data.getID() == PlayerMCCreeper.getID())
		{
			if(%this.cloakCharge $= "")
				%this.cloakCharge = 5000;
			if(%trig == 0)
			{
				if(%tog)
				{
					cancel(%this.creepSched);
					%this.creepTime = getSimTime();
					%this.creepSched = %this.schedule(5, "creeperSwell");
					%this.playAudio(0, CreeperFuseSound);
				}
				else
				{
					cancel(%this.creepSched);
					%this.creepTime = getSimTime();
					%this.creepSched = %this.schedule(5, "creeperShrink");
					%this.stopAudio(0);
				}
			}
			else if(%trig == 4 && %tog)
			{
				if(%this.cloaking)
				{
					%this.cloaking = 0;
					cancel(%this.cloakSched);
					%this.unhideNode("ALL");
					%this.setShapeNameDistance(1000);
					%this.cloakTime = getSimTime();
					%this.cloakSched = %this.schedule(5, "cloakRestore");
				}
				else if(%this.cloakCharge > 0 && %this.swell == 0 && $Pref::Server::MC_Creeper::AllowCloaking)
				{
					%this.cloaking = 1;
					cancel(%this.cloakSched);
					%this.hideNode("ALL");
					%this.setShapeNameDistance(0);
					%this.cloakTime = getSimTime();
					%this.cloakSched = %this.schedule(5, "cloakDrain");
				}
			}
		}
		Parent::onTrigger(%data, %this, %trig, %tog);
	}
	
	function Armor::onDisabled(%data, %this, %lastState)
	{
		Parent::onDisabled(%data, %this, %lastState);
		if(%data.getID() == PlayerMCCreeper.getID())
		{
			%this.playAudio(0, CreeperDeathSound);
			%this.cloaking = 0;
			cancel(%this.creepSched);
			cancel(%this.cloakSched);
			%this.hideNode("ALL");
		}
	}
	
	function servercmdUseTool(%cl, %slot)
	{
		if(isObject(%pl = %cl.player) && %pl.getDatablock().getID() == PlayerMCCreeper.getID())
			%cl.chatMessage("\c6Silly %1! The <color:008000>Creeper\c6 has no arms! What're you gonna hold that "@(isObject(%tool = %pl.tool[%slot])?trim(%tool.uiName)@" with?":"... wait a second. You cheater you! You don't have an item there!"));
		else
			Parent::servercmdUseTool(%cl, %slot);
	}
	
	function servercmdLight(%cl)
	{
		if(isObject(%pl = %cl.player) && %pl.getDatablock().getID() == PlayerMCCreeper.getID())
			%cl.chatMessage("\c6Silly %1! The <color:008000>Creeper\c6 has no arms! What're you gonna hold that light with?");
		else
			Parent::servercmdLight(%cl);
	}
	
	function servercmdUseHammer(%cl)
	{
		if(isObject(%pl = %cl.player) && %pl.getDatablock().getID() == PlayerMCCreeper.getID())
			%cl.chatMessage("\c6Silly %1! The <color:008000>Creeper\c6 has no arms! What're you gonna hold that Hammer with?");
		else
			Parent::servercmdUseHammer(%cl);
	}
	
	function servercmdUsePrintGun(%cl)
	{
		if(isObject(%pl = %cl.player) && %pl.getDatablock().getID() == PlayerMCCreeper.getID())
			%cl.chatMessage("\c6Silly %1! The <color:008000>Creeper\c6 has no arms! What're you gonna hold that Printer with?");
		else
			Parent::servercmdUsePrintGun(%cl);
	}
};
activatePackage("CreeperGoesBoom");

function Player::creeperSwell(%pl)
{
	%time = vectorDist(%pl.creepTime, %sim = getSimTime());
	%pl.creepTime = %sim;
	%pl.swell += %time;
	if(%pl.getState() $= "DEAD")
	{
		%pl.setScale("1 1 1");
		%pl.stopAudio(0);
		%pl.swell = 0;
		return;
	}
	if(%pl.swell >= 1500)
	{
		%damage = %pl.getDamageLevel();
		%pl.setDamageLevel(0);
		%pl.damage(0, 0, 20, $DamageType::Default);
		if(%pl.getDamageLevel() != 0)
		{
			%pl.swell = 0;
			%pl.setScale("1 1 1");
			%pl.setDamageLevel(%damage);
			%pl.spawnExplosion(("CreeperProjectile"@getRandom(0,3)).getID(), 1, %pl.client);
			if(%pl.getDamageLevel() == 0)
				%pl.kill();
			%pl.stopAudio(0);
			%pl.delete();
		}
		else
		{
			%pl.setDamageLevel(%damage);
			%pl.creepSched = %pl.schedule(5, "creeperShrink");
			%pl.stopAudio(0);
			return;
		}
	}
	else
	{
		%skew = 1 + (%pl.swell / 3000);
		%pl.setScale(%skew SPC %skew SPC 1);
		%pl.creepSched = %pl.schedule(5, "creeperSwell");
		if(isObject(%cl = %pl.client))
		{
			if(isObject(%cl = %pl.client)) %cl.creeperPrint();
			if(%pl.swell >= 1000 && !%pl.creeperDontAlertTeam)
			{
				initContainerRadiusSearch(%pl.getHackPosition(), 8, $Typemasks::PlayerObjectType);
				while(isObject(%obj = containerSearchNext()))
					if(%obj.getState() !$= "DEAD" && %obj != %pl && %obj.getDatablock().getID() == PlayerMCCreeper.getID())
						%client[-1+%clients++] = %obj.client.name;
				if(%clients != 0)
				{
					for(%i=0;%i<%clients;%i++)
						if(%i == 0)
							%nameList = %client0;
						else if(%i == %clients - 1 && %clients != 1)
							%nameList = %nameList@(%clients!=2?",":"")@" and "@%client[%i];
						else
							%nameList = %nameList@", "@%client[%i];
					servercmdTeamMessageSent(%cl, "I'm about to explode! "@%nameList@(%clients>2?":":",")@" get out of the way!");
					%pl.schedule(5000, "creeperCanAlertTeam");
					%pl.creeperDontAlertTeam = 1;
				}
			}
		}
	}
}

function Player::creeperShrink(%pl)
{
	%time = vectorDist(%pl.creepTime, %sim = getSimTime());
	%pl.creepTime = %sim;
	%pl.swell -= %time;
	if(%pl.getState() $= "DEAD")
	{
		%pl.setScale("1 1 1");
		%pl.swell = 0;
		return;
	}
	if(%pl.swell <= 0)
	{
		%pl.setScale("1 1 1");
		%pl.swell = 0;
		return;
	}
	else
	{
		%skew = 1 + (%pl.swell / 3000);
		%pl.setScale(%skew SPC %skew SPC 1);
		%pl.creepSched = %pl.schedule(5, "creeperShrink");
		if(isObject(%cl = %pl.client)) %cl.creeperPrint();
	}
}

function Player::cloakDrain(%pl)
{
	if(%pl.getState() $= "DEAD" || %pl.cloakCharge <= 0 || %pl.swell != 0 || !$Pref::Server::MC_Creeper::AllowCloaking)
	{
		%pl.cloaking = 0;
		%pl.cloakSched = %pl.schedule(5, "cloakRestore");
		%pl.setShapeNameDistance(1000);
		%pl.unhideNode("ALL");
		return;
	}
	else
	{
		%time = vectorDist(%pl.cloakTime, %sim = getSimTime());
		%pl.cloakTime = %sim;
		%pl.cloakCharge -= %time;
		%pl.cloakSched = %pl.schedule(5, "cloakDrain");
		if(isObject(%cl = %pl.client)) %cl.creeperPrint();
	}
}

function Player::cloakRestore(%pl)
{
	%time = vectorDist(%pl.cloakTime, %sim = getSimTime());
	%pl.cloakTime = %sim;
	%pl.cloakCharge += %time;
	if(%pl.getState() $= "DEAD")
		return;
	if(%pl.cloakCharge >= 5000)
	{
		%pl.cloakCharge = 5000;
		return;
	}
	else
	{
		%pl.cloakSched = %pl.schedule(5, "cloakRestore");
		if(isObject(%cl = %pl.client)) %cl.creeperPrint();
	}
}

function Player::creeperCanAlertTeam(%pl)
{ %pl.creeperDontAlertTeam = 0; }

function GameConnection::creeperPrint(%cl)
{
	if(!isObject(%pl = %cl.player))
		return;
	%fuse = (1500 - %pl.swell) / 1000; if(%fuse < 0) %fuse = 0;
	%cloak = %pl.cloakCharge / 1000; if(%cloak < 0) %cloak = 0;
	%cl.bottomPrint("<color:FFFFFF>Fuse: "@mFloatLength(%fuse, 1)@($Pref::Server::MC_Creeper::AllowCloaking?"   Cloak: "@mFloatLength(%cloak, 1):""), 3);
}

new ProjectileData(CreeperProjectile : TankShellProjectile)
{
	directDamageType = $DamageType::Creeper;
	radiusDamageType = $DamageType::Creeper;
};

datablock AudioProfile(CreeperFuseSound)
{
	description = AudioClosestLooping3D;
	filename = "Add-Ons/Player_Creeper/Creeper_Fuse.wav";
	preload = 1;
};

datablock AudioProfile(CreeperDeathSound)
{
	description = AudioClosest3D;
	filename = "Add-Ons/Player_Creeper/Creeper_Death.wav";
	preload = 1;
};

datablock AudioProfile(CreeperExplodeSound0 : RocketExplodeSound) { filename = "Add-Ons/Player_Creeper/Creeper_Explode1.wav"; };
datablock ExplosionData(CreeperExplosion0 : TankShellExplosion) { uiName = "Creeper 0"; soundProfile = CreeperExplodeSound0; };
datablock ProjectileData(CreeperProjectile0 : TankShellProjectile) { uiName = "Creeper 0"; explosion = CreeperExplosion0; };

datablock AudioProfile(CreeperExplodeSound1 : RocketExplodeSound) { filename = "Add-Ons/Player_Creeper/Creeper_Explode2.wav"; };
datablock ExplosionData(CreeperExplosion1 : TankShellExplosion) { uiName = "Creeper 1"; soundProfile = CreeperExplodeSound1; };
datablock ProjectileData(CreeperProjectile1 : TankShellProjectile) { uiName = "Creeper 1"; explosion = CreeperExplosion1; };

datablock AudioProfile(CreeperExplodeSound2 : RocketExplodeSound) { filename = "Add-Ons/Player_Creeper/Creeper_Explode3.wav"; };
datablock ExplosionData(CreeperExplosion2 : TankShellExplosion) { uiName = "Creeper 2"; soundProfile = CreeperExplodeSound2; };
datablock ProjectileData(CreeperProjectile2 : TankShellProjectile) { uiName = "Creeper 2"; explosion = CreeperExplosion2; };

datablock AudioProfile(CreeperExplodeSound3 : RocketExplodeSound) { filename = "Add-Ons/Player_Creeper/Creeper_Explode4.wav"; };
datablock ExplosionData(CreeperExplosion3 : TankShellExplosion) { uiName = "Creeper 3"; soundProfile = CreeperExplodeSound3; };
datablock ProjectileData(CreeperProjectile3 : TankShellProjectile) { uiName = "Creeper 3"; explosion = CreeperExplosion3; };